import App


# Support functions for Foundation-related ship AI

speedBoost = 40
accelBoost = 0.10
powerDrain = 2.2 # -RidgeDweller's
# Special thanks to jwatts_jr for helping to figure out the proper syntax
# for accessing the SetMax methods. -Dasher42

def EnableInterceptSpeed(pShip):
	pProp = pShip.GetImpulseEngineSubsystem().GetProperty()
	maxSpeed = pProp.GetMaxSpeed()
	maxAccel = pProp.GetMaxAccel()
	maxPower = pProp.GetNormalPowerPerSecond()
	
	if maxSpeed and maxSpeed <= 60:
		maxSpeed = maxSpeed + 60
	if maxAccel and maxAccel <= 400:
		maxAccel = maxAccel + 400
	if maxSpeed and maxSpeed <= 2400:
		pProp.SetMaxSpeed(maxSpeed * speedBoost)
		pProp.SetMaxAccel(maxAccel * accelBoost)
		pProp.SetNormalPowerPerSecond(maxPower * powerDrain)

def DisableInterceptSpeed(pShip):
	pProp = pShip.GetImpulseEngineSubsystem().GetProperty()
	maxSpeed = pProp.GetMaxSpeed()
	maxAccel = pProp.GetMaxAccel()
	maxPower = pProp.GetNormalPowerPerSecond()
	
	if maxSpeed and maxSpeed >= 2400:
		maxSpeed = (maxSpeed / speedBoost)
		pProp.SetMaxSpeed(maxSpeed)
		pProp.SetMaxAccel(maxAccel / accelBoost)
		pProp.SetNormalPowerPerSecond(maxPower / powerDrain)
		
		#next 4 lines no longer needed -RidgeDweller
		#currentSpeed = pShip.GetVelocityTG().Length()
		#if currentSpeed > maxSpeed:
			#pShip.SetSpeed( maxSpeed, App.TGPoint3_GetModelForward(), App.PhysicsObjectClass.DIRECTION_MODEL_SPACE )
			#pShip.SetVelocity(App.TGPoint3_GetModelForward())

# Standard motion formula variables
# u = initial velocity
# s = distance
# v = final velocity
# t = time
# a = acceleration
# m = mass
# Of course, because the ships do slam on the brakes at their final dest. i.e. Dasher's Intercept_Dasher,
# these Had to be altered to use their full potential. -RidgeDweller

def AccelerationDistance(u, a):
#	fCurrentSpeed = pShip.GetVelocityTG().Length()
#	pMass = pShip.GetSoveriegnSubsystem().GetProperty()
#	mShipMass = pMass.GetMass()
#	iVelocity = fCurrentSpeed * mShipMass
	t = u / (a * 0.75)
	return u * t + 0.5 * (a * 0.75) * (t * t)

def DecelerationDistance(u, a):
#	fCurrentSpeed = pShip.GetVelocityTG().Length()
#	pMass = pShip.GetSoveriegnSubsystem().GetProperty()
#	mShipMass = pMass.GetMass()
#	iVelocity = fCurrentSpeed * mShipMass
	t = u / (a * 0.75)
	return u * t - 0.5 * (a * 0.75) * (t * t) # Well this is cheating but it works. I tried to
#					figure mass into the picture,(See above) but the ship just stopped!!!! -RD
